package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.LandMark;
import com.izouma.awesomeadmin.service.LandMarkService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/landMark")
public class LandMarkController {

    @Autowired
    private LandMarkService landMarkService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(LandMark record) {
        List<LandMark> pp = landMarkService.getLandMarkList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getLandMark", method = RequestMethod.GET)
    @ResponseBody
    public Result getLandMark(@RequestParam(required = false, value = "id") String id) {
        LandMark data = landMarkService.getLandMarkById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(LandMark record) {
        LandMark data = landMarkService.getLandMark(record);
        return new Result(true, data);
    }


    @RequestMapping(value = "/mapInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result mapInfo(LandMark record) {
        LandMark data = landMarkService.getLandMarkMapInfo(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, LandMark record) {
        Map<String, Object> result = new HashMap<>();

        List<LandMark> pp = landMarkService.getLandMarkByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>分页查询。本城市没有则显示其他城市的</p>
     */
    @RequestMapping(value = "/pageByCity", method = RequestMethod.GET)
    @ResponseBody
    public Result pageByCity(Page page, LandMark record) {
        Map<String, Object> result = new HashMap<>();

        List<LandMark> pp = landMarkService.getCityLandMarkByPage(page, record);

        if (pp.isEmpty()) {
            record.setOwnedCityId(null);
            pp = landMarkService.getCityLandMarkByPage(page, record);
        }

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    @RequestMapping(value = "/child", method = RequestMethod.GET)
    @ResponseBody
    public Result child(LandMark record) {
        List<LandMark> pp = landMarkService.getLandMarkChildList(record);
        return new Result(true, pp);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(LandMark record) {
        boolean num = landMarkService.createLandMark(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateLandMark(LandMark record) {
        boolean num = landMarkService.updateLandMark(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteLandMark(LandMark record) {

        boolean num = landMarkService.deleteLandMark(record);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, LandMark record) throws Exception {

        List<LandMark> landMarks = landMarkService.getLandMarkList(record);


        String sheetName = "land_mark";
        String titleName = "地标信息数据表";
        String fileName = "地标信息表";
        int columnNumber = 27;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"ID", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "地标名称", "所属城市Id", "缩略图", "地点Loge图", "营业/开放情况", "地标简介", "识别图组名称", "模式", "识别图集ID", "识别图集数据名称", "地图信息", "地图宽", "地图高", "比率", "是否显示", "经度", "纬度", "备注1", "备注2", "备注3", "上级地标ID"};
        String[][] dataList = new String[landMarks.size()][27];

        for (int i = 0; i < landMarks.size(); i++) {

            dataList[i][0] = String.valueOf(landMarks.get(i).getId());
            dataList[i][1] = String.valueOf(landMarks.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(landMarks.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(landMarks.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(landMarks.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(landMarks.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(landMarks.get(i).getMapName());
            dataList[i][7] = String.valueOf(landMarks.get(i).getOwnedCityId());
            dataList[i][8] = String.valueOf(landMarks.get(i).getMapSprite());
            dataList[i][9] = String.valueOf(landMarks.get(i).getLogeSprite());
            dataList[i][10] = String.valueOf(landMarks.get(i).getOpenDescribe());
            dataList[i][11] = String.valueOf(landMarks.get(i).getMarkDescribe());
            dataList[i][12] = String.valueOf(landMarks.get(i).getAnchorImageGroupName());
            dataList[i][13] = String.valueOf(landMarks.get(i).getDefaultMode());
            dataList[i][14] = String.valueOf(landMarks.get(i).getVuforiaImageGroupId());
            dataList[i][15] = String.valueOf(landMarks.get(i).getVuforiaDataName());
            dataList[i][16] = String.valueOf(landMarks.get(i).getMapInfo());
            dataList[i][17] = String.valueOf(landMarks.get(i).getMapWidth());
            dataList[i][18] = String.valueOf(landMarks.get(i).getMapHeight());
            dataList[i][19] = String.valueOf(landMarks.get(i).getMapRate());
            dataList[i][20] = String.valueOf(landMarks.get(i).getShowInPanel());
            dataList[i][21] = String.valueOf(landMarks.get(i).getLongitude());
            dataList[i][22] = String.valueOf(landMarks.get(i).getLatitude());
            dataList[i][23] = String.valueOf(landMarks.get(i).getRemark1());
            dataList[i][24] = String.valueOf(landMarks.get(i).getRemark2());
            dataList[i][25] = String.valueOf(landMarks.get(i).getRemark3());
            dataList[i][26] = String.valueOf(landMarks.get(i).getFrontLevelId());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }
}

